// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct ListAsyncInvokesInput {
    /// <p>Include invocations submitted after this time.</p>
    pub submit_time_after: ::std::option::Option<::aws_smithy_types::DateTime>,
    /// <p>Include invocations submitted before this time.</p>
    pub submit_time_before: ::std::option::Option<::aws_smithy_types::DateTime>,
    /// <p>Filter invocations by status.</p>
    pub status_equals: ::std::option::Option<crate::types::AsyncInvokeStatus>,
    /// <p>The maximum number of invocations to return in one page of results.</p>
    pub max_results: ::std::option::Option<i32>,
    /// <p>Specify the pagination token from a previous request to retrieve the next page of results.</p>
    pub next_token: ::std::option::Option<::std::string::String>,
    /// <p>How to sort the response.</p>
    pub sort_by: ::std::option::Option<crate::types::SortAsyncInvocationBy>,
    /// <p>The sorting order for the response.</p>
    pub sort_order: ::std::option::Option<crate::types::SortOrder>,
}
impl ListAsyncInvokesInput {
    /// <p>Include invocations submitted after this time.</p>
    pub fn submit_time_after(&self) -> ::std::option::Option<&::aws_smithy_types::DateTime> {
        self.submit_time_after.as_ref()
    }
    /// <p>Include invocations submitted before this time.</p>
    pub fn submit_time_before(&self) -> ::std::option::Option<&::aws_smithy_types::DateTime> {
        self.submit_time_before.as_ref()
    }
    /// <p>Filter invocations by status.</p>
    pub fn status_equals(&self) -> ::std::option::Option<&crate::types::AsyncInvokeStatus> {
        self.status_equals.as_ref()
    }
    /// <p>The maximum number of invocations to return in one page of results.</p>
    pub fn max_results(&self) -> ::std::option::Option<i32> {
        self.max_results
    }
    /// <p>Specify the pagination token from a previous request to retrieve the next page of results.</p>
    pub fn next_token(&self) -> ::std::option::Option<&str> {
        self.next_token.as_deref()
    }
    /// <p>How to sort the response.</p>
    pub fn sort_by(&self) -> ::std::option::Option<&crate::types::SortAsyncInvocationBy> {
        self.sort_by.as_ref()
    }
    /// <p>The sorting order for the response.</p>
    pub fn sort_order(&self) -> ::std::option::Option<&crate::types::SortOrder> {
        self.sort_order.as_ref()
    }
}
impl ListAsyncInvokesInput {
    /// Creates a new builder-style object to manufacture [`ListAsyncInvokesInput`](crate::operation::list_async_invokes::ListAsyncInvokesInput).
    pub fn builder() -> crate::operation::list_async_invokes::builders::ListAsyncInvokesInputBuilder {
        crate::operation::list_async_invokes::builders::ListAsyncInvokesInputBuilder::default()
    }
}

/// A builder for [`ListAsyncInvokesInput`](crate::operation::list_async_invokes::ListAsyncInvokesInput).
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
#[non_exhaustive]
pub struct ListAsyncInvokesInputBuilder {
    pub(crate) submit_time_after: ::std::option::Option<::aws_smithy_types::DateTime>,
    pub(crate) submit_time_before: ::std::option::Option<::aws_smithy_types::DateTime>,
    pub(crate) status_equals: ::std::option::Option<crate::types::AsyncInvokeStatus>,
    pub(crate) max_results: ::std::option::Option<i32>,
    pub(crate) next_token: ::std::option::Option<::std::string::String>,
    pub(crate) sort_by: ::std::option::Option<crate::types::SortAsyncInvocationBy>,
    pub(crate) sort_order: ::std::option::Option<crate::types::SortOrder>,
}
impl ListAsyncInvokesInputBuilder {
    /// <p>Include invocations submitted after this time.</p>
    pub fn submit_time_after(mut self, input: ::aws_smithy_types::DateTime) -> Self {
        self.submit_time_after = ::std::option::Option::Some(input);
        self
    }
    /// <p>Include invocations submitted after this time.</p>
    pub fn set_submit_time_after(mut self, input: ::std::option::Option<::aws_smithy_types::DateTime>) -> Self {
        self.submit_time_after = input;
        self
    }
    /// <p>Include invocations submitted after this time.</p>
    pub fn get_submit_time_after(&self) -> &::std::option::Option<::aws_smithy_types::DateTime> {
        &self.submit_time_after
    }
    /// <p>Include invocations submitted before this time.</p>
    pub fn submit_time_before(mut self, input: ::aws_smithy_types::DateTime) -> Self {
        self.submit_time_before = ::std::option::Option::Some(input);
        self
    }
    /// <p>Include invocations submitted before this time.</p>
    pub fn set_submit_time_before(mut self, input: ::std::option::Option<::aws_smithy_types::DateTime>) -> Self {
        self.submit_time_before = input;
        self
    }
    /// <p>Include invocations submitted before this time.</p>
    pub fn get_submit_time_before(&self) -> &::std::option::Option<::aws_smithy_types::DateTime> {
        &self.submit_time_before
    }
    /// <p>Filter invocations by status.</p>
    pub fn status_equals(mut self, input: crate::types::AsyncInvokeStatus) -> Self {
        self.status_equals = ::std::option::Option::Some(input);
        self
    }
    /// <p>Filter invocations by status.</p>
    pub fn set_status_equals(mut self, input: ::std::option::Option<crate::types::AsyncInvokeStatus>) -> Self {
        self.status_equals = input;
        self
    }
    /// <p>Filter invocations by status.</p>
    pub fn get_status_equals(&self) -> &::std::option::Option<crate::types::AsyncInvokeStatus> {
        &self.status_equals
    }
    /// <p>The maximum number of invocations to return in one page of results.</p>
    pub fn max_results(mut self, input: i32) -> Self {
        self.max_results = ::std::option::Option::Some(input);
        self
    }
    /// <p>The maximum number of invocations to return in one page of results.</p>
    pub fn set_max_results(mut self, input: ::std::option::Option<i32>) -> Self {
        self.max_results = input;
        self
    }
    /// <p>The maximum number of invocations to return in one page of results.</p>
    pub fn get_max_results(&self) -> &::std::option::Option<i32> {
        &self.max_results
    }
    /// <p>Specify the pagination token from a previous request to retrieve the next page of results.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.next_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>Specify the pagination token from a previous request to retrieve the next page of results.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.next_token = input;
        self
    }
    /// <p>Specify the pagination token from a previous request to retrieve the next page of results.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.next_token
    }
    /// <p>How to sort the response.</p>
    pub fn sort_by(mut self, input: crate::types::SortAsyncInvocationBy) -> Self {
        self.sort_by = ::std::option::Option::Some(input);
        self
    }
    /// <p>How to sort the response.</p>
    pub fn set_sort_by(mut self, input: ::std::option::Option<crate::types::SortAsyncInvocationBy>) -> Self {
        self.sort_by = input;
        self
    }
    /// <p>How to sort the response.</p>
    pub fn get_sort_by(&self) -> &::std::option::Option<crate::types::SortAsyncInvocationBy> {
        &self.sort_by
    }
    /// <p>The sorting order for the response.</p>
    pub fn sort_order(mut self, input: crate::types::SortOrder) -> Self {
        self.sort_order = ::std::option::Option::Some(input);
        self
    }
    /// <p>The sorting order for the response.</p>
    pub fn set_sort_order(mut self, input: ::std::option::Option<crate::types::SortOrder>) -> Self {
        self.sort_order = input;
        self
    }
    /// <p>The sorting order for the response.</p>
    pub fn get_sort_order(&self) -> &::std::option::Option<crate::types::SortOrder> {
        &self.sort_order
    }
    /// Consumes the builder and constructs a [`ListAsyncInvokesInput`](crate::operation::list_async_invokes::ListAsyncInvokesInput).
    pub fn build(
        self,
    ) -> ::std::result::Result<crate::operation::list_async_invokes::ListAsyncInvokesInput, ::aws_smithy_types::error::operation::BuildError> {
        ::std::result::Result::Ok(crate::operation::list_async_invokes::ListAsyncInvokesInput {
            submit_time_after: self.submit_time_after,
            submit_time_before: self.submit_time_before,
            status_equals: self.status_equals,
            max_results: self.max_results,
            next_token: self.next_token,
            sort_by: self.sort_by,
            sort_order: self.sort_order,
        })
    }
}
